var ttControllers = angular.module('transfertoControllers', ['transfertoServices']);


// data save names
var _clientActivity_ = "clientActivity";
var _thisMonthAmount_ = "thismonth";
var _lastMonthAmount_ = "lastmonth";
var _operatorData_ = "operatordata";
var _phoneNumber_ = "phoneNumber"; // string ex:'639273688122'
var _lang_ = "lang"; // "en" "in" ...
var _ts_ = "timestamp"; // long int
var _lastmsgnumber_ = "lastmsgnumber";
var _profile_ = "profile";

// config
var datatimeout = 60; // seconds

var requesttimeout = 20000;

// main controller

ttControllers.controller('MainCtrl', ['$scope', '$ionicSideMenuDelegate', '$ionicPlatform', '$http', 
                                      function($scope, $ionicSideMenuDelegate, $ionicPlatform, $http) {
    if(typeof analytics !== "undefined") { 
        console.log('Make a call to analytics with MainCtrl');
        analytics.trackView("Main Controller"); 
    }
    else
    {
        console.log("Problem loading analytics");
    }
	$scope.toggleLeft = function() {
		$ionicSideMenuDelegate.toggleLeft();
	};
	
	// storage
	$scope.storeData = function(name,data) {
		var ed = JSON.stringify(data);
		//console.log("STORING "+ name+" >> "+ed);
		localStorage.setItem( name, ed);
	}
	$scope.getStoredData = function(name) {
		try{
			var ed = localStorage.getItem(name);
			if (ed==null) return null;
			return JSON.parse(ed);
		} catch(e) {
			console.log(e);
			return null;
		}
	}

	$scope.resetData = function(endstep)
	{
		$scope.userActivity = []; 
		$scope.thismonth = [{curamount:"0"}];
		$scope.lastmonth = [{curamount:"0"}];
		$scope.requestClientData(endstep);
	}
	
	// Receiver / Sender

	$scope.updateProfileRS = function(endstep)
	{
		setTimeout(function () {
			//console.log($scope.Profile.RecSend);
			$scope.storeData(_profile_ , $scope.Profile);
			$scope.updateRecSend();
			$scope.resetData(endstep);
		},0);
		
	}
	
	$scope.updateRecSend = function() // update displayed texts (not content data)
	{
		if ($scope.Profile.RecSend=='R')
		{
			$scope.totalAmountLib = $scope.lang.page.index_page.total_amount_received;
			$scope.topupButtonLib = $scope.lang.page.multiple_pages.request_top_up;
		}
		else
		{
			$scope.totalAmountLib = $scope.lang.page.index_page.total_amount_sent;
			$scope.topupButtonLib = $scope.lang.page.multiple_pages.send_top_up;
		}
	}
	
	// Transactions & amounts (API request)
	
	$scope.formatObj = function(obj) // format transactions, amounts ..
	{
		if (obj==null) return null;
		if (obj.date)
			obj.date = obj.date.replace(' ','T');
		
		if (obj.currency)
			if (obj.currency=='INR') obj.curamount = "Rs. "+obj.amount;
			else if (obj.currency=='PHP') obj.curamount = "P"+obj.amount;
			else if (obj.currency=='IDR') obj.curamount = "Rp "+obj.amount.replace(/000$/,',000');
			else if (obj.currency=='SGD') obj.curamount = "SG$"+obj.amount;
			else if (obj.currency=='USD') obj.curamount = "US$"+obj.amount;
			else if (obj.currency=='CUC') obj.curamount = "CUC$"+obj.amount;
			else if (obj.currency=='MYR') obj.curamount = "RM"+obj.amount;
			else if (obj.currency=='SAR') obj.curamount = "SR"+obj.amount;
			else obj.curamount = obj.currency+obj.amount;
 		//console.log("formatObj: "+obj.currency+" "+obj.amount+" => "+obj.curamount);
		
		if ($scope.Profile.RecSend=='R') obj.name = obj.sender;
			else obj.name = obj.receiver;
		if (obj.name) obj.name = obj.name.trim();
		if ((obj.name)&&(obj.name.charAt(0)!="+")&&(!isNaN(obj.name))) obj.name = "+"+obj.name;
		
		if (obj.country) { // detail picture
			obj.image="img/banners/ads-2.jpg"; // default
			var cy = obj.country.toLowerCase().replace(' ','_');
			if ((cy=="hong_kong")||(cy=="india")||(cy=="indonesia")||(cy=="malaysia")
					||(cy=="philippines")||(cy=="saudi_arabia")||(cy=="singapore")||(cy=="usa"))
				obj.image="img/locations/"+cy+".jpg";
			console.log("img: "+obj.image);
		}
	}
	
	$scope.getCheckData = function() {//imsi, uuid, connection_type
		var d = "";
		if ((navigator)&&(navigator.connection)&&(navigator.connection.type)) {
			d = d+"&connection_type="+encodeURIComponent(navigator.connection.type);
		}
		if ((device)&&(device.uuid)) {
			d = d+"&uuid="+encodeURIComponent(device.uuid);
		}
		if ((cordova)&&(cordova.plugins)&&(cordova.plugins.uid)&&(cordova.plugins.uid.IMSI)) {
			d = d+"&imsi="+encodeURIComponent(cordova.plugins.uid.IMSI);
		}
		console.log("check:"+d);
		return d;
	}
	
	$scope.requestClientData = function(endstep) {
		if ($scope.refreshLoad == $scope.lang.page.multiple_pages.loading) { console.log("requestClientData already running"); return; }
		
		$scope.refreshLoad = $scope.lang.page.multiple_pages.loading;
		$scope.refreshClass = "animated";
		
		console.log("requestClientData");
		// - Transactions -
		var _url = apiBaseURL+'/transactions?client='+apiClient+'&key='+apiKey+'&msisdn='+$scope.phoneNumber+$scope.getCheckData();
 		console.log("transactions "+$scope.phoneNumber);
 		$http({method: 'GET', url: _url, timeout: requesttimeout}).
 	    success(function(data) {
 	    	console.log("transactions OK");
 	    	//console.log("transactions: "+JSON.stringify(data));
 	    	var obj = data.sent;
 	    	if ($scope.Profile.RecSend=='R') obj = data.received;
 	    	if (!obj) obj = [];
 	    	for (var i=0;i<obj.length;i++) $scope.formatObj(obj[i]); 
 	    	$scope.userActivity=obj;
 	    	$scope.storeData(_clientActivity_, obj);
			$scope.datats=(new Date()).getTime();
 			$scope.storeData(_ts_ , $scope.datats);
 			$scope.refreshLoad = $scope.lang.page.index_page.refresh;
 			$scope.refreshClass = "";
 			if (endstep) endstep();
 	    })
 	    .error(function(er) {
 	    	console.log("transactions ERROR "+er);
 	    	$scope.refreshLoad = $scope.lang.page.index_page.refresh;
 			$scope.refreshClass = "";
 			if (endstep) endstep();
 	    });
 		
 		// - Amounts -
		var _url = apiBaseURL+'/retail_value/this_month?client='+apiClient+'&key='+apiKey+'&msisdn='+$scope.phoneNumber;
 		$http({method: 'GET', url: _url, timeout: requesttimeout}).
 	    success(function(data) {
 	    	var o = [{curamount:"0"}];
 	    	var obj = data.sent;
 	    	if ($scope.Profile.RecSend=='R') obj = data.received;
 	    	console.log("this_month: "+JSON.stringify(data)+" "+_url+" "+$scope.Profile.RecSend+" "+obj.length);
 	    	if ((obj)&&(obj.length>0))
 	    	{
 	    		for (var i=0;i<obj.length;i++) $scope.formatObj(obj[i]);
 	    		o = obj;
	 	    	/*var k = Object.getOwnPropertyNames(obj);
	 	    	if (k.length>0)
	 	    	{
	 	    		o.currency = Object.getOwnPropertyNames(obj)[0];
	 	    		o.amount = obj[o.currency];
	 	    	}*/
	 	    }
 	    	$scope.thismonth=o;
 	    	$scope.storeData(_thisMonthAmount_, $scope.thismonth);
 	    });
 		
		var _url = apiBaseURL+'/retail_value/last_month?client='+apiClient+'&key='+apiKey+'&msisdn='+$scope.phoneNumber;
 		$http({method: 'GET', url: _url, timeout: requesttimeout}).
 	    success(function(data) {
 	    	console.log("last_month: "+JSON.stringify(data)+" "+_url);
 	    	var o = [{curamount:"0"}];
 	    	var obj = data.sent;
 	    	if ($scope.Profile.RecSend=='R') obj = data.received;
 	    	//console.log("obj> "+JSON.stringify(obj));
 	    	if ((obj)&&(obj.length>0))
 	    	{
 	    		for (var i=0;i<obj.length;i++) $scope.formatObj(obj[i]);
 	    		o = obj;
	 	    }
 	    	$scope.lastmonth=o;
 	    	$scope.storeData(_lastMonthAmount_, $scope.lastmonth);
 	    });
 		//.error(onError);		

 		// reload profile ?
 		if ($scope.Profile.reloadserverdata) $scope.requestProfile();
 		
	} // requestClientData
	
	$scope.refresh = function()	{
		$scope.requestClientData();
	}
	
	// Numbers from transactions
	
	$scope.getLastReceiverNumber = function() {
		console.log("getLastReceiverNumber "+$scope.userActivity.length);
		if (($scope.item)&&($scope.item.obj)&&($scope.item.obj.receiver)) {
//			console.log("using item receiver");
			return ($scope.item.obj.receiver);
		}
		if ($scope.userActivity) {
			var i;
			for (i=0;i<$scope.userActivity.length;i++)
			{
				var transac = $scope.userActivity[i];
				if (transac.receiver) return transac.receiver;
			}
		}
		return null;
	}
	$scope.getLastSenderNumber = function() {
//		console.log("getLastSenderNumber "+$scope.userActivity.length);
		if (($scope.item)&&($scope.item.obj)&&($scope.item.obj.sender)) {
//			console.log("using item sender");
			return ($scope.item.obj.sender);
		}
		if ($scope.userActivity) {
			var i;
			for (i=0;i<$scope.userActivity.length;i++)
			{
				var transac = $scope.userActivity[i];
				if (transac.sender) return transac.sender;
			}
		}
		return null;
	}
	
	// PhoneNumber configuration
	
	$scope.splitPhoneNumber = function() {
		$scope.number = splitNumber($scope.phoneNumber);
	}
	
	$scope.newPhoneNumber = function(pn, endstep) {
		console.log("newPhoneNumber "+pn+"/"+$scope.phoneNumber);
		if (!pn) return;
		if (pn.charAt(0)=='+') pn=pn.substring(1);
		if (pn==$scope.phoneNumber) { if (endstep) endstep(); return; }
		
		$scope.phoneNumber = pn;
		$scope.splitPhoneNumber();
		$scope.storeData(_phoneNumber_ , pn);
		
		// update data..
		$scope.Profile = {'firstname':'', 'lastname':'',
				'email':'',
				'birth_day':'', 'birth_month':'', 'birth_year':'',
				'RecSend':'S'};
		var n = pn;
		if ((n.substring(0,2)=="63")||(n.substring(0,2)=="62")||(n.substring(0,2)=="91")) // philippines indonesia  india
			$scope.Profile.RecSend = "R";
		
		$scope.updateProfileRS(endstep); // resetData updateRecSend & save
		$scope.loadProfile();
		$scope.requestOperator();
		$scope.storeData(_lastmsgnumber_, "");
	}
	
	// Language configuration
	
	$scope.selectTranslation = function() {
		if ($scope.language=="id") $scope.lang = lang_id;
		else if ($scope.language=="in") $scope.lang = lang_in;
		else if ($scope.language=="ph") $scope.lang = lang_ph;
		else $scope.lang = lang_en;
		$scope.refreshLoad = $scope.lang.page.index_page.refresh;
	}
	
	$scope.setLang = function(l) {
		$scope.language = l;
		$scope.selectTranslation();
		$scope.storeData(_lang_ , l);
		$scope.updateRecSend();
	}
	
	// Transactions Detail
	
	$scope.transactionDetail = function(index)
	{
		if ((!$scope.userActivity)||(index<0)||(index>=$scope.userActivity.length)) return;
		$scope.item.index = index;
		$scope.item.obj = $scope.userActivity[index];
		$scope.item.tofrom = $scope.lang.page.details_page.to;
		if ($scope.Profile.RecSend=='R') $scope.item.tofrom = $scope.lang.page.details_page.from;
		$scope.item.sendrec = $scope.lang.page.details_page.send_more_top_up;
		if ($scope.Profile.RecSend=='R') $scope.item.sendrec = $scope.lang.page.details_page.request_more_top_up;
		$scope.item.prev = (index>0);
		$scope.item.next = (index<$scope.userActivity.length-1);
		console.log("detail "+index+" prev:"+$scope.item.prev+" next:"+$scope.item.next+" T/F:"+$scope.item.tofrom);
		window.location = "#/event/detail";
	}
	
	// Profile (API Request)
	
	$scope.serverSaveProfile = function(endstep) {
		console.log("serverSaveProfile");
		
		var nextstep = function(userexist) {
			console.log("next");
			if ($scope.Profile.serverdata)
			{
				if (!userexist)
						$scope.sendProfile("POST", endstep);
					else
						$scope.sendProfile("PUT", endstep);
			}
			else $scope.sendProfile("POST", endstep);//if (endstep) endstep();
		}
		
		if (!$scope.Profile.serverdata)
		{
			$scope.requestProfile(nextstep);
		} else {
			nextstep(true);
		}
	}
	
	$scope.loadProfile = function() {
		console.log("loadProfile");
		$scope.requestProfile(function(success){
			if (success)
			{
				$scope.Profile.firstname = $scope.Profile.serverdata.firstname;
				$scope.Profile.lastname = $scope.Profile.serverdata.lastname;
				$scope.Profile.email = $scope.Profile.serverdata.email;
				if ($scope.Profile.serverdata.birthday) {
					var bdate = $scope.Profile.serverdata.birthday.split("-");
					$scope.Profile.birth_year = bdate[0];
					$scope.Profile.birth_month = bdate[1];
					$scope.Profile.birth_day = bdate[2];
				}
				$scope.storeData(_profile_ , $scope.Profile);
			}
		})
	}
	
	$scope.requestProfile = function(nextstep) {
		var _url = apiBaseURL+'/user?client='+apiClient+'&key='+apiKey+'&msisdn='+$scope.phoneNumber;
		console.log("requestProfile: "+_url);

		
		var xhr = new XMLHttpRequest();
		xhr.open("GET", _url, true);
		xhr.retfunc = function(r) {
 	    	console.log("request user: "+r);
 	    	try {
	 	    	var data = JSON.parse(r);
	 	    	if (data)
	 	    	{
	 	    		$scope.Profile.serverdata = data;
	 	    		$scope.Profile.reloadserverdata = false;
	 	    		if (nextstep) nextstep(true);
	 	    		$scope.storeData(_profile_ , $scope.Profile);
	 	    	}
 	    	}
 	    	catch (ex) { console.log(ex); if (this.errfunc!=null) this.errfunc(); }
		};
		xhr.errfunc = function(statuscode) {
 	    	console.log("request user ERROR");
 	    	if (statuscode!=400) // 400: no user for this msisdn
 	    	{
 	    		$scope.Profile.reloadserverdata = true;
 	    	}
    		if (nextstep) nextstep(false);
		};
		xhr.timeout = requesttimeout+10000;
		xhr.ontimeout = function () { console.log("request user timeout"); if (this.errfunc!=null) this.errfunc(0); }
		xhr.pdata = null;
		xhr.onreadystatechange = function()
		{
			console.log(">> "+this.readyState+" / "+this.status+" "+this.statusText+" "+this.responseText);
			if(this.readyState == 3) { // save data (in case of problem in state 4)
				if (this.status==200) {
					this.pdata = this.responseText;
				}
			}
			else if(this.readyState == 4) {
				if (this.status==200) {
					this.pdata = this.responseText;
				}
				if ((this.pdata)&&(this.retfunc!=null)) this.retfunc(this.pdata);
				else if (this.errfunc!=null) this.errfunc(this.status);
			}
			else if ((this.readyState == 2)&&(this.status!=200))
			{
				if (this.errfunc!=null) this.errfunc(this.status,this.statusText);
			}
		};
		xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded; charset=UTF-8");
		xhr.send();
/*
		
		$http({method: 'GET', url: _url, timeout: requesttimeout,
 		   headers: {
 		       "Accept": "application/json; charset=utf-8",
 		       "Accept-Charset": "charset=utf-8"
 		   }
 		}).
 	    success(function(data) {
 	    	console.log("request user: "+JSON.stringify(data));
 	    	if (data)
 	    	{
 	    		$scope.Profile.serverdata = data;
 	    		if (nextstep) nextstep(true);
 	    		$scope.storeData(_profile_ , $scope.Profile);
 	    	}
 	    	
 	    })
 	    .error(function(data, code, headers, config) {
 	    	console.log("err requestProfile "+JSON.stringify(data)+" "+code+" headers:"+JSON.stringify(headers)+" config:"+JSON.stringify(config));
 	    	if (data)
 	    	{
 	    		$scope.Profile.serverdata = data;
 	    	}
 	    	var exists = false;
 	    	if (code==0) exists = true; // case: non-standard characters in exsiting profile
    		if (nextstep) nextstep(exists);
 	    });*/
	}
	
	$scope.sendProfile = function(method, end) {
		var _url = apiBaseURL+'/user?client='+apiClient+'&key='+apiKey+'&msisdn='+$scope.phoneNumber;
		var pdata = {};
		pdata.firstname = $scope.Profile.firstname;
		pdata.lastname = $scope.Profile.lastname;
		pdata.email = $scope.Profile.email;
		pdata.birthday = $scope.Profile.birth_year+"-"+$scope.Profile.birth_month+"-"+$scope.Profile.birth_day;
		
		console.log("sending: "+JSON.stringify(pdata));
		
 		$http({'method': method, 'url': _url, timeout: requesttimeout, 'contentType': "application/json; charset=utf-8",
 			'data': pdata }).
 	    success(function(data) {
 	    	console.log("senduser: "+JSON.stringify(data));
 	    	//$scope.Profile.serverdata = data; // useful ?
 	    	if (end) end();
 	    })
 	    .error(function(data) {
 	    	console.log("error sendProfile: "+JSON.stringify(data));
 	    	var msg = "undefined";
 	    	if ((typeof(data)=="object")&&(data.errors)&&(data.errors.length>0))
 	    		msg = data.errors[0].message;
 	    	showAlert("Error: "+msg, end);
 	    	//if (end) end();
 	    });
 	    
	}
	
	// Top-up / Operator

	$scope.requestOperator = function() {
		var _url = apiBaseURL+'/topup_methods?client='+apiClient+'&key='+apiKey+'&msisdn='+$scope.phoneNumber;
		
 		$http({method: 'GET', url: _url, timeout: requesttimeout}).
 	    success(function(data) {
 	    	console.log("operator: "+JSON.stringify(data));
 	    	if (data)
 	    	{
 	    		$scope.Profile.operator = data;
 	    		$scope.storeData(_profile_ , $scope.Profile);
 	    	}
 	    	
 	    })
 	    .error(function(data) {
 	    	console.log("err requestOperator "+JSON.stringify(data));
 	    });
 	    
	}


	/* {"operator":"China Mobile Hong Kong",
	 "ussd":{"ussd_initial_step":"*142*%b_number%*%denomination%#","ussd_code":"142"},
	 "sms":{"sms_initial_step":"%b_number%","sms_code":"8526226494949"},
	 "operatorid":1823}
	 */
	$scope.sendTopup = function() {
		
		if ((!$scope.Profile.operator)||
				((!$scope.Profile.operator.sms)&&(!$scope.Profile.operator.uuid))) {
			window.location = "#/event/sendlist";
		} else {
			if (!$scope.Profile.operator.sms)
				window.location = "#/event/sendussd";
			else {
				window.location = "#/event/sendsms";
				// "sms:"+$scope.Profile.operator.sms.sms_code+"?body="+encodeURIComponent($scope.Profile.operator.sms.sms_initial_step)
			}
		}
	}
	
	// click on request/send topup button
	$scope.topupButton = function(useItem) {
		if (!useItem) { $scope.item.obj = null; $scope.item.index = -1; }
		if ($scope.Profile.RecSend=='R')
			window.location = "#/event/request";
		else {
			if ((!$scope.Profile.firstname)&&(!$scope.Profile.lastname)&&(!$scope.Profile.skip))
			{
				el = document.getElementById("profileprompt-modal");
				if (el) el.style.visibility = "visible";
				else $scope.sendTopup();
				return;
			}
			
			$scope.sendTopup();
		}
	}
	
	$scope.skipProfilePrompt = function() {
		$scope.Profile.skip = true;
 		$scope.storeData(_profile_ , $scope.Profile);
		$scope.sendTopup();
	}
	$scope.saveProfilePrompt = function() {
		$scope.Profile.firstname = document.getElementById("promptfirstname").value;
		$scope.Profile.lastname = document.getElementById("promptlastname").value;
 		$scope.storeData(_profile_ , $scope.Profile);
 		$scope.serverSaveProfile();
		$scope.sendTopup();
	}
	
	// Messages
	
	$scope.msgLengthLeft = function(msg) {
		var chars7bit = {'@': 1, '£': 1, '$': 1, '¥': 1, 'è': 1, 'é': 1, 'ù': 1, 'ì': 1, 'ò': 1, 'Ç': 1, "\n":1, 'Ø': 1, 'ø': 1, "\r":1, 'Å': 1, 'å': 1, 'Δ': 1, '_': 1, 'Φ': 1, 'Γ': 1, 'Λ': 1, 'Ω': 1, 'Π': 1, 'Ψ': 1, 'Σ': 1, 'Θ': 1, 'Ξ': 1, 'Æ': 1, 'æ': 1, 'ß': 1, 'É': 1, ' ': 1, '!': 1, '"': 1, '#': 1, '¤': 1, '%': 1, '&': 1, "'":1, '(': 1, ')': 1, '*': 1, '+': 1, ',': 1, '-': 1, '.': 1, '/': 1, '0': 1, '1': 1, '2': 1, '3': 1, '4': 1, '5': 1, '6': 1, '7': 1, '8': 1, '9': 1, ':': 1, ';': 1, '<': 1, '=': 1, '>': 1, '?': 1, '¡': 1, 'A': 1, 'B': 1, 'C': 1, 'D': 1, 'E': 1, 'F': 1, 'G': 1, 'H': 1, 'I': 1, 'J': 1, 'K': 1, 'L': 1, 'M': 1, 'N': 1, 'O': 1, 'P': 1, 'Q': 1, 'R': 1, 'S': 1, 'T': 1, 'U': 1, 'V': 1, 'W': 1, 'X': 1, 'Y': 1, 'Z': 1, 'Ä': 1, 'Ö': 1, 'Ñ': 1, 'Ü': 1, '§': 1, '¿': 1, 'a': 1, 'b': 1, 'c': 1, 'd': 1, 'e': 1, 'f': 1, 'g': 1, 'h': 1, 'i': 1, 'j': 1, 'k': 1, 'l': 1, 'm': 1, 'n': 1, 'o': 1, 'p': 1, 'q': 1, 'r': 1, 's': 1, 't': 1, 'u': 1, 'v': 1, 'w': 1, 'x': 1, 'y': 1, 'z': 1, 'ä': 1, 'ö': 1, 'ñ': 1, 'ü': 1, 'à': 1, "\f": 2, '^': 2, '{': 2, '}': 2, '\\': 2, '[': 2, '~': 2, ']': 2, '|': 2, '€': 2};
		var i;
		var mode7bit = true;
		var lg = 0;
		for (i=0;i<msg.length;i++) {
			var ch = msg.charAt(i);
			if (chars7bit[ch] === undefined) { lg += 2; mode7bit = false; }
			else lg += chars7bit[ch];
		}
		return 90-lg;
		/*
		if (mode7bit) return 160-lg;
		else return 70-msg.length;
		*/
	}
	
	// misc ui
	
	$scope.openWeb = function(url) {
		if (navigator.connection.type=="none") {
 			showAlert($scope.lang.page.multiple_pages.no_connection, function() {
 				window.location = "#/event/home";
 			});
			return;
		}
		//navigator.app.loadUrl(url, {openExternal : true});
		window.open(url, '_blank', 'location=yes');
	}
	
	// -- Inits --
	$scope.refreshLoad = "Loading";
	$scope.refreshClass = "animated";
	$scope.number = { country:"+", local:"" };
	$scope.item = { index:-1, obj:null, prev:false, next:false, tofrom:"To"};
	$scope.photoProfile = "img/profile_blank.png";
	
	// test data
	//if ($scope.getStoredData( _phoneNumber_ )==null) $scope.storeData(_phoneNumber_ , '919544808979');
	
	// default data
	$scope.language = 'en';
	if ($scope.getStoredData( _lang_ )==null)
		$scope.storeData(_lang_ , $scope.language);
	
	$scope.Profile = {'firstname':'', 'lastname':'',
			'email':'',
			'birth_day':'', 'birth_month':'', 'birth_year':'',
			'RecSend':'S'};
	if ($scope.getStoredData( _profile_ )==null)
	{
		// Receiver or Sender by country
		var n = $scope.getStoredData( _phoneNumber_ );
		if ((n!=undefined) && ((n.substring(0,2)=="63")||(n.substring(0,2)=="62")||(n.substring(0,2)=="91"))) // philippines indonesia  india
			$scope.Profile.RecSend = "R";
		$scope.storeData(_profile_ , $scope.Profile );
	}
	
	// load stored data 
	
	$scope.language = $scope.getStoredData( _lang_ );
	$scope.selectTranslation();
	
	$scope.phoneNumber = $scope.getStoredData( _phoneNumber_ );
	
	$scope.Profile = $scope.getStoredData( _profile_ );
	console.log("profile read : "+ JSON.stringify($scope.Profile));

	$scope.updateRecSend();
	
	$scope.userActivity = $scope.getStoredData( _clientActivity_ ); 
		//[{"sender":"test","amount":"125","currency":"PHP","date":"2014-01-01T10:20:30.4567","country":"Unknown"},{"sender":"test2","amount":"250","currency":"PHP","date":"2014-01-02T11:30:40.4567","country":"Nowhere"}]; for (j=0;j<2;j++) $scope.formatObj($scope.userActivity[j]);
	$scope.thismonth = $scope.getStoredData( _thisMonthAmount_ ); //{ currency:"PHP", amount:"50"};
	$scope.lastmonth = $scope.getStoredData( _lastMonthAmount_ );
	
 	if (!$scope.lastmonth) $scope.lastmonth=[{curamount:"0"}];
 	if (!$scope.thismonth) $scope.thismonth=[{curamount:"0"}];
	
	
	
	$scope.datats = $scope.getStoredData( _ts_ );
	
	// onReady (cordova plugins)
	
	$ionicPlatform.ready(function () {
		console.log("ionicPlatform - ready ! "+$scope.phoneNumber);
		
		$scope.refreshLoad = $scope.lang.page.index_page.refresh;
		$scope.refreshClass = "";

		/*
		document.addEventListener("backbutton", function () {
			navigator.app.exitApp();
		}, false);
		*/
		if ($scope.phoneNumber!=null) {
			if ( (typeof($scope.datats)!="number")
					|| ($scope.datats<(new Date()).getTime()-(datatimeout*1000)) )
			{
				$scope.requestClientData();
				$scope.loadProfile();
				$scope.requestOperator();
			}
		}
        if(typeof analytics !== "undefined") {
            console.log('Start google analytics tracking');
            analytics.startTrackerWithId('UA-48630624-1');
            analytics.trackView("Application started"); 
        } else {
            console.log("Google Analytics Unavailable");
        }
		
		//console.log("value: "+$("#mobile-number").val()+" - "+$scope.number.country);
		//$().intlTelInput();
		$scope.splitPhoneNumber();

		console.log('connection:' + navigator.connection.type+" uuid:"+device.uuid);
		console.log('IMSI:'+cordova.plugins.uid.IMSI);
	}); // $ionicPlatform.ready
	
}])

.controller('HomeCtrl', ['$scope', '$ionicSideMenuDelegate', 'PhoneNumber', 
function($scope, $ionicSideMenuDelegate, PhoneNumber) {
    if(typeof analytics !== "undefined") { 
        console.log('Make a call to analytics with HomeCtrl');
        analytics.trackView("Home Controller"); 
    }
    else
    {
        console.log("Problem loading analytics");
    }

	window.mySwipe = Swipe(document.getElementById('mySwipe'), {
		startSlide: 0,
		auto: 3000,
		continuous: true,
		disableScroll: true,
		callback: function(pos) {
			var i = bullets.length;
			while (i--) {
				bullets[i].className = ' ';
			}
			bullets[pos].className = 'on';
		}
	});
	var sp = document.getElementById('swipeposition');
	if (sp!=null) window.bullets = sp.getElementsByTagName('li'); 

}])

.controller('ChangeNumberController', ['$scope', '$ionicSideMenuDelegate', function($scope, $ionicSideMenuDelegate) {
    if(typeof analytics !== "undefined") { 
        console.log('Make a call to analytics with ChangeNumberController');
        analytics.trackView("ChangeNumberController"); 
    }
	console.log('ChangeNumberController '+JSON.stringify($scope.number));
	
	$("#changeNumberForm #country-code").val($scope.number.country);
	$("#changeNumberForm #mobile-number").val($scope.number.local);

	try {
		$("#changeNumberForm #mobile-number").intlTelInput();
		selectFlag($scope.number.code,document.querySelector("#changeNumberForm"));
		//"setNumber", $scope.number.country+$scope.number.local
		$scope.working_state = "";
	} catch (ex) { console.log("ERR: "+JSON.stringify(ex)); }
	
	console.log("changeNumber: "+ JSON.stringify($scope.number));
	
	$scope.updatePhoneNumber = function()
	{
		if (navigator.connection.type=="none") { showAlert($scope.lang.page.multiple_pages.no_connection); return; }
		var numcountry = $("#changeNumberForm #country-code").val();
		var numlocal = $("#changeNumberForm #mobile-number").val();
		if (!numlocal) return; 
		var num = numcountry + numlocal;
		//console.log("updatePhoneNumber "+num);
		num = num.substring(1);
		$scope.working_state = " - "+$scope.lang.page.multiple_pages.updating;
		$scope.newPhoneNumber(num,function(){$scope.working_state = "";	window.location='#/event/home';});
		//setTimeout(function(){window.location='#/event/home'},200);
		return false;
	}
}])

.controller('MessageController', ['$scope', '$http', '$ionicSideMenuDelegate', function($scope, $http, $ionicSideMenuDelegate) {
    if(typeof analytics !== "undefined") { 
        console.log('Make a call to analytics with MessageController');
        analytics.trackView("MessageController"); 
    }
	console.log('MessageController');
	
	$scope.message = { title:$scope.lang.page.message_page.send_message,
			subtitle:"",
			defaultmsg:"",
			button:$scope.lang.page.message_page.send_for_free};
	
	$scope.placeholder = $scope.lang.page.change_number.enter_phone_number;
	var lastnum=null;
	
	// transaction selected ?
	if ($scope.item.obj) {
		lastnum = splitNumber($scope.item.obj.name);
		console.log("item_num: "+$scope.item.obj.name);
	}
	
	if ((!lastnum)||(lastnum.country=="+")) // lastmsgnumber ?
		lastnum = splitNumber($scope.getStoredData(_lastmsgnumber_));
	
	if (lastnum.country=="+") { // first transaction ?
		if ($scope.Profile.RecSend=='R')
			lastnum = splitNumber($scope.getLastSenderNumber());
		else
			lastnum = splitNumber($scope.getLastReceiverNumber());
	}
	
	if (lastnum.country=="+") { // default my country
		lastnum.country=$scope.number.country; lastnum.code=$scope.number.code;
	}
	if ((lastnum.country=="+")||(lastnum.country=="")) { // default ph 
		lastnum.country="+63"; lastnum.code="ph";
	}

	$("#country-code").val(lastnum.country);
	$("#mobile-number").val(lastnum.local);
	
	$("#mobile-number").intlTelInput();
	selectFlag(lastnum.code);
	$scope.working_state = "";
	
	$scope.sendMessage = function()
	{
		var numcountry = $("#country-code").val();
		var numlocal = $("#mobile-number").val();
		var num = (numcountry + numlocal).substring(1); 
		var msg = $("#msgtext").val();
		var mll = $scope.msgLengthLeft(msg);
		console.log("message: "+num+" "+msg+" lg:"+mll+" conn.:"+navigator.connection.type)
		
		if (!numlocal) { showAlert($scope.lang.page.multiple_pages.empty_number); return; }
		$scope.storeData(_lastmsgnumber_, num);
		
		if (!msg) { showAlert($scope.lang.page.multiple_pages.empty_message); return; }
		if (mll<0) { showAlert($scope.lang.page.multiple_pages.message_too_long+" : "+(0-mll)); return; }
		if (navigator.connection.type=="none") { showAlert($scope.lang.page.multiple_pages.no_connection); return; }

		var _url = apiBaseURL+'/send_message?client='+apiClient+'&key='+apiKey+'&msisdn='+$scope.phoneNumber;
		var method = "POST";
		var pdata = {};
		pdata.target =  num;
		pdata.content = msg;
		
		console.log("sending: "+JSON.stringify(pdata));
		$scope.working_state = " - "+$scope.lang.page.multiple_pages.sending;
		
 		$http({'method': method, 'url': _url, 'timeout':requesttimeout, 'data': JSON.stringify(pdata)}).
 	    success(function(data) {
 	    	console.log("sendMessage: "+_url+" "+JSON.stringify(data));
 			$scope.working_state = "";
 			showAlert($scope.lang.page.message_page.message_sent, function() {
 				window.location = "#/event/home";
 			});
 	    })
 	    .error(function(data) {
 	    	console.log("error sendMessage: "+JSON.stringify(data));
 	    	var errmsg = $scope.lang.page.multiple_pages.no_sever_response;
 	    	if ((data.errors)&&(data.errors[0])) errmsg= data.errors[0].message; 
 	    	// 
 	    	if (errmsg=="INVALID_DEST_MSISDN") errmsg = $scope.lang.page.message_page.invalid_number;
 	    	if (errmsg=="SMS_NOT_SENT") errmsg = $scope.lang.page.message_page.impossible_number;
 			$scope.working_state = "";
 			showAlert(errmsg);
 	    });
		

//		setTimeout(function(){window.location='#/event/home'},200);
		return false;
	}
}])


.controller('RequestTopUpController', ['$scope', '$http', '$ionicSideMenuDelegate', function($scope, $http, $ionicSideMenuDelegate) {
    if(typeof analytics !== "undefined") { 
        console.log('Make a call to analytics with RequestTopUpController');
        analytics.trackView("RequestTopUpController"); 
    }
	console.log('RequestTopUpController');
	
	$scope.message = { title:$scope.lang.page.multiple_pages.request_top_up,
		    subtitle:$scope.lang.page.request_top_up_page.request_from_friend,
			defaultmsg:$scope.lang.page.request_top_up_page.message_text,
			button:$scope.lang.page.request_top_up_page.request_for_free};
	
	var lastnum = splitNumber($scope.getLastSenderNumber());
	// $scope.getStoredData(_lastmsgnumber_) ?
	if (lastnum.country=="+") {
		if ($scope.number.code=='ph') {
			lastnum.country="+966";
			lastnum.code="sa";
		}
		else if ($scope.number.code=='id') {
			lastnum.country="+60";
			lastnum.code="my";
		}
		else if ($scope.number.code=='in') {
			lastnum.country="+966";
			lastnum.code="sa";
		}
		else {
			lastnum.country=$scope.number.country;
			lastnum.code=$scope.number.code;
		}
	}
	if (lastnum.country=="+") { lastnum.country="+63"; lastnum.code="ph"; }

	$("#country-code").val(lastnum.country);
	$("#mobile-number").val(lastnum.local);
	
	$("#mobile-number").intlTelInput();
	selectFlag(lastnum.code);
	$scope.working_state = "";
	
	$scope.sendMessage = function()
	{
		var numcountry = $("#country-code").val();
		var numlocal = $("#mobile-number").val();
		var num = (numcountry + numlocal).substring(1); 
		var msg = $("#msgtext").val();
		var mll = $scope.msgLengthLeft(msg);
		
		if (!numlocal) { showAlert($scope.lang.page.multiple_pages.empty_number); return; }
//		$scope.storeData(_lastmsgnumber_, num);
		
		if (!msg) { showAlert($scope.lang.page.multiple_pages.empty_message); return; }
		if (mll<0) { showAlert($scope.lang.page.multiple_pages.message_too_long+" : "+(0-mll)); return; }
		if (navigator.connection.type=="none") { showAlert($scope.lang.page.multiple_pages.no_connection); return; }
		
		var _url = apiBaseURL+'/topup_requests?client='+apiClient+'&key='+apiKey+'&msisdn='+$scope.phoneNumber;
		console.log("_url: "+_url);
		var method = "POST";
		var pdata = {};
		pdata.target =  num;
		pdata.content = msg;
		
		console.log("sending: "+JSON.stringify(pdata));
		$scope.working_state = " - "+$scope.lang.page.multiple_pages.sending;
		
 		$http({'method': method, 'url': _url, 'timeout':requesttimeout, 'data': JSON.stringify(pdata)}).
 	    success(function(data) {
 	    	console.log("sendMessage: "+_url+" "+JSON.stringify(data));
 			$scope.working_state = "";
 			showAlert($scope.lang.page.message_page.message_sent, function() {
 				window.location = "#/event/home";
 			});
 	    })
 	    .error(function(data) {
 	    	console.log("error sendMessage: "+JSON.stringify(data));
 	    	var errmsg = $scope.lang.page.multiple_pages.no_sever_response;
 	    	if ((data.errors)&&(data.errors[0])) errmsg= data.errors[0].message; 
 	    	// 
 	    	if (errmsg=="INVALID_DEST_MSISDN") errmsg = $scope.lang.page.message_page.invalid_number;
 	    	if (errmsg=="SMS_NOT_SENT") errmsg = $scope.lang.page.message_page.impossible_number;
 			$scope.working_state = "";
 			showAlert(errmsg);
 	    });
	}
}])

.controller('InviteCtrl', ['$scope', '$http', '$ionicSideMenuDelegate', function($scope, $http, $ionicSideMenuDelegate) {
    if(typeof analytics !== "undefined") { 
        console.log('Make a call to analytics with InviteCtrl');
        analytics.trackView("InviteCtrl"); 
    }
	console.log('InviteCtrl');
	
	$scope.message = { title:$scope.lang.page.invite_page.invite_friends,
		    subtitle:$scope.lang.page.invite_page.invite_for_free,
			defaultmsg:$scope.lang.page.invite_page.invite_text,
			button:$scope.lang.page.invite_page.send_for_free};
	
	var lastnum = splitNumber($scope.getStoredData(_lastmsgnumber_));
	if (lastnum.country=="+") {
		lastnum.country=$scope.number.country;
		lastnum.code=$scope.number.code;
	}
	if (lastnum.country=="+") { lastnum.country="+63"; lastnum.code="ph"; }

	$("#country-code").val(lastnum.country);
	$("#mobile-number").val(lastnum.local);
	
	$("#mobile-number").intlTelInput();
	selectFlag(lastnum.code);
	
	$scope.working_state = "";
	
	$scope.sendMessage = function()
	{
		var numcountry = $("#country-code").val();
		var numlocal = $("#mobile-number").val();
		var num = (numcountry + numlocal).substring(1); 
		var msg = $("#msgtext").val();
		var mll = $scope.msgLengthLeft(msg);
		console.log("message: "+num+" "+msg)
		
		if (!numlocal) { showAlert($scope.lang.page.multiple_pages.empty_number); return; }
		$scope.storeData(_lastmsgnumber_, num);

		if (!msg) { showAlert($scope.lang.page.multiple_pages.empty_message); return; }
		if (mll<0) { showAlert($scope.lang.page.multiple_pages.message_too_long+" : "+(0-mll)); return; }
		if (navigator.connection.type=="none") { showAlert($scope.lang.page.multiple_pages.no_connection); return; }
		
		var _url = apiBaseURL+'/send_message?client='+apiClient+'&key='+apiKey+'&msisdn='+$scope.phoneNumber;
		var method = "POST";
		var pdata = {};
		pdata.target =  num;
		pdata.content = msg;
		
		console.log("sending: "+JSON.stringify(pdata));
		$scope.working_state = " - "+$scope.lang.page.multiple_pages.sending;
		
 		$http({'method': method, 'url': _url, 'timeout':requesttimeout, 'data': JSON.stringify(pdata)}).
 	    success(function(data) {
 	    	console.log("sendMessage: "+_url+" "+JSON.stringify(data));
 			$scope.working_state = "";
 			showAlert($scope.lang.page.message_page.message_sent, function() {
 				window.location = "#/event/home";
 			});
 	    })
 	    .error(function(data) {
 	    	console.log("error sendMessage: "+JSON.stringify(data));
 	    	var errmsg = $scope.lang.page.multiple_pages.no_sever_response;
 	    	if ((data.errors)&&(data.errors[0])) errmsg= data.errors[0].message; 
 	    	// 
 	    	if (errmsg=="INVALID_DEST_MSISDN") errmsg = $scope.lang.page.message_page.invalid_number;
 	    	if (errmsg=="SMS_NOT_SENT") errmsg = $scope.lang.page.message_page.impossible_number;
 			$scope.working_state = "";
 			showAlert(errmsg);
 	    });
	}
}])

.controller('ProfileController', ['$scope', '$http', '$ionicSideMenuDelegate', function($scope, $http, $ionicSideMenuDelegate) {
    if(typeof analytics !== "undefined") { 
        console.log('Make a call to analytics with ProfileController');
        analytics.trackView("ProfileController"); 
    }
	console.log('ProfileController');
	
	var i;
	var a  = [];

	var y = (new Date()).getFullYear();
	for (i=0;i<60;i++) {
		var v = ""+(y-(i+10));
		a.push(v);
	}
	$scope.listyears = a;

	a  = [];
	for (i=1;i<=12;i++) {
		var v = ""+i; if (i<10) v="0"+v;
		a.push(v);
	}
	$scope.listmonths = a;

	a  = [];
	for (i=1;i<=31;i++) {
		var v = ""+i; if (i<10) v="0"+v;
		a.push(v);
	}
	$scope.listdays = a;
	
	$scope.update = { state : "" };
	
	var images = {
			"hk":"hong_kong",
			"sg":"singapore",
			"us":"usa",
			"id":"indonesia",
			"in":"india",
			"ph":"philippines",
			"my":"malaysia",
			"sa":"saudi_arabia"
	};
	
	
	$scope.bgProfile = "generic";
	if (($scope.number.code)&&(images[$scope.number.code]))
		$scope.bgProfile = images[$scope.number.code];
	
	$scope.photoProfile = "img/profile_blank.png";
	if (($scope.Profile.serverdata)&&($scope.Profile.serverdata.profile))
		$scope.photoProfile = $scope.Profile.serverdata.profile;

	console.log("profile photo: "+$scope.photoProfile+" "+JSON.stringify($scope.Profile.serverdata));
	
	myPicInit($scope.photoProfile);
	
	$scope.saveProfile = function()
	{
		console.log("profil >"+ JSON.stringify($scope.Profile));
		$scope.update.state = " - "+$scope.lang.page.multiple_pages.sending;
		$scope.storeData(_profile_ , $scope.Profile);
		
		$scope.serverSaveProfile(function () {
			console.log("end saving profile");
			$scope.update.state = "";
			$scope.$apply(function () {
				try {
				$scope.update.state = "";
				} catch (e) {}
	        });
		});
	}
	
	$scope.uploadPhoto = function() {
		if (!$scope.Profile.serverdata)
		{
			$scope.Profile.serverdata = {};
		}
		$scope.Profile.serverdata.profile=window.img_code;
		$scope.storeData(_profile_ , $scope.Profile);
		
		var n = window.img_code.indexOf("base64")+7;
		var pdata = {};
		pdata.avatar = window.img_code.substring(n);
		
		//console.log(window.img_code);
		//console.log("sending: "+JSON.stringify(pdata));
		var end = function() { $scope.update.state = ""; window.location="#/event/profile"; }
		
		$scope.update.state = " - "+$scope.lang.page.multiple_pages.sending;
		
		var _url = apiBaseURL+'/user/avatar?client='+apiClient+'&key='+apiKey+'&msisdn='+$scope.phoneNumber;
		var method = "POST";
 		$http({'method': method, 'url': _url, timeout: 40000, 'contentType': "application/json; charset=utf-8",
 			'data': pdata }).
 	    success(function(data) {
 	    	console.log("send avatar: "+JSON.stringify(data));
 	    	//$scope.Profile.serverdata.profile = data.url;
 	    	if (end) end();
 	    })
 	    .error(function(data) {
 	    	console.log("error send avatar: "+JSON.stringify(data));
 	    	var msg = "undefined";
 	    	if ((typeof(data)=="object")&&(data.errors)&&(data.errors.length>0))
 	    		msg = data.errors[0].message;
 	    	showAlert("Error: "+msg, end);
 	    	//if (end) end();
 	    });
		
	}
	
	
}])

.controller('SendUSSDController', ['$scope', '$ionicSideMenuDelegate', function($scope, $ionicSideMenuDelegate) {
	console.log('SendUSSDController');
	var number = $scope.getLastReceiverNumber();
	if (number==null) number = "%b_number%";
	
	//"ussd":{"ussd_initial_step":"*142*%b_number%*%denomination%#","ussd_code":"142"},
	$scope.ussd_code = $scope.Profile.operator.ussd.ussd_code;
	$scope.ussd_initial_step = $scope.Profile.operator.ussd.ussd_initial_step
		.replace("%b_number%",number);//.replace("%denomination%","denomination");
	
}])
.controller('SendSMSController', ['$scope', '$ionicSideMenuDelegate', function($scope, $ionicSideMenuDelegate) {
	console.log('SendSMSController');
	var number = $scope.getLastReceiverNumber();
	if (number==null) number = "%b_number%";

	//"sms":{"sms_initial_step":"%b_number%","sms_code":"8526226494949"},
	$scope.sms_code = $scope.Profile.operator.sms.sms_code;
	$scope.sms_initial_step = $scope.Profile.operator.sms.sms_initial_step
		.replace("%b_number%",number);
	
	// encodeURIComponent ?
	document.getElementById("sendsms").href = "sms:"+$scope.sms_code+"?body="+$scope.sms_initial_step;
	
}])

.controller('FeedbackController', ['$scope', '$http', '$ionicSideMenuDelegate', function($scope, $http, $ionicSideMenuDelegate) {
	console.log('FeedbackController');
	
	$scope.content = "";
	$scope.working_state = "";

	$scope.submitFeedback = function(  ) {

		var _url = apiBaseURL+'/feedback?client='+apiClient+'&key='+apiKey+'&msisdn='+$scope.phoneNumber;
		var method = "POST";
		var pdata = {};
		pdata.content = $("#content").val();
		
		if (!pdata.content) { showAlert($scope.lang.page.multiple_pages.empty_message); return; }
		if (navigator.connection.type=="none") { showAlert($scope.lang.page.multiple_pages.no_connection); return; }
		console.log("sending: "+JSON.stringify(pdata));
		
		$scope.working_state = " - "+$scope.lang.page.multiple_pages.sending;

 		$http({'method': method, 'url': _url, 'timeout':requesttimeout, 'data': JSON.stringify(pdata)}).
 	    success(function(data) {
 	    	console.log("submitFeedback: "+JSON.stringify(data));
 			showAlert($scope.lang.page.message_page.message_sent, function() {
 				window.location = "#/event/home";
 			});
 	    })
 	    .error(function(data) {
 	    	console.log("error submitFeedback: "+JSON.stringify(data));
 	    	var errmsg = $scope.lang.page.multiple_pages.no_sever_response;
 	    	if ((data.errors)&&(data.errors[0])) errmsg= data.errors[0].message; 
 	    	$scope.working_state = "";
 	    	showAlert(errmsg);
 	    });
	}
	 
}])


.controller('ContactController', ['$scope', '$http', '$ionicSideMenuDelegate', function($scope, $http, $ionicSideMenuDelegate) {
	console.log('ContactController');
	
	$scope.content = "";
	$scope.working_state = "";

	$scope.submitContact = function(  ) {

		var _url = apiBaseURL+'/contact?client='+apiClient+'&key='+apiKey+'&msisdn='+$scope.phoneNumber;
		var method = "POST";
		var pdata = {};
		pdata.content = $("#content").val();
		
		if (!pdata.content) { showAlert($scope.lang.page.multiple_pages.empty_message); return; }
		pdata.content = pdata.content+"\nEmail: "+$("#contactEmail").val();
		if (navigator.connection.type=="none") { showAlert($scope.lang.page.multiple_pages.no_connection); return; }
		console.log("sending: "+JSON.stringify(pdata));
		
		$scope.working_state = " - "+$scope.lang.page.multiple_pages.sending;
						
 		$http({'method': method, 'url': _url, 'timeout':requesttimeout, 'data': JSON.stringify(pdata)}).
 	    success(function(data) {
 	    	console.log("submitContact: "+JSON.stringify(data));
 	    	$scope.working_state = "";
 			showAlert($scope.lang.page.message_page.message_sent, function() {
 				window.location = "#/event/home";
 			});
 	    })
 	    .error(function(data) {
 	    	console.log("error submitContact: "+JSON.stringify(data));
 	    	var errmsg = $scope.lang.page.multiple_pages.no_sever_response;
 	    	if ((data.errors)&&(data.errors[0])) errmsg= data.errors[0].message; 
 	    	$scope.working_state = "";
 	    	showAlert(errmsg);
 	    });
	}
	 
}])


;

