// ----- angular

angular.module('transferto', ['ionic','transfertoControllers'])



.directive('fadeBar', function($timeout) {
  return {
    restrict: 'E',
    template: '<div class="fade-bar"></div>',
    replace: true,
    link: function($scope, $element, $attr) {
      // Run in the next scope digest
      $timeout(function() {
        // Watch for changes to the openRatio which is a value between 0 and 1 that says how "open" the side menu is
        $scope.$watch('sideMenuController.getOpenRatio()', function(ratio) {
          // Set the transparency of the fade bar
          $element[0].style.opacity = Math.abs(ratio);
        });
      });
    }
  }
})

.directive('ngPlaceholder', function($document) {
  return {
    restrict: 'A',
    scope: {
      placeholder: '=ngPlaceholder'
    },
    link: function(scope, elem, attr) {
      scope.$watch('placeholder',function() {
        elem[0].placeholder = scope.placeholder;
      });
    }
  }
})

.directive('dynamicPlaceholder',
    function() {
        return {                
            restrict: 'A',
            link: function ($scope, element, attrs) {
                attrs.$observe('dynamicPlaceholder', function(value) {
                    element.attr('placeholder', value);
                });
            }
        };
    })

.config(function($stateProvider, $urlRouterProvider) {

  $stateProvider
    .state('eventmenu', {
      url: "/event",
      abstract: true,
      templateUrl: "event-menu.html"
    })
    .state('eventmenu.home', {
      url: "/home",
      views: {
        'menuContent' :{
          templateUrl: "home.html",
          controller: "HomeCtrl"
        }
      }
    })
    .state('eventmenu.detail', {
      url: "/detail",
      views: {
        'menuContent' :{
          templateUrl: "detail.html"
        }
      }
    })
    .state('eventmenu.activity', {
      url: "/activity",
      views: {
        'menuContent' :{
          templateUrl: "activity.html"
        }
      }
    })
    .state('eventmenu.language', {
      url: "/language",
      views: {
        'menuContent' :{
          templateUrl: "language.html"
        }
      }
    })
    .state('eventmenu.changenber', {
      url: "/changenumber",
      views: {
        'menuContent' :{
          templateUrl: "changenumber.html",
          controller: "ChangeNumberController"
        }
      }
    })
    .state('eventmenu.profile', {
      url: "/profile",
      views: {
        'menuContent' :{
          templateUrl: "profile.html",
          controller: "ProfileController"
        }
      }
    })
    .state('eventmenu.photo', {
      url: "/photo",
      views: {
        'menuContent' :{
          templateUrl: "photo.html",
          controller: "ProfileController"
        }
      }
    })
    .state('eventmenu.invite', {
      url: "/invite",
      views: {
        'menuContent' :{
          templateUrl: "invite.html",
          controller: "InviteCtrl"
        }
      }
    })
    .state('eventmenu.request', {
      url: "/request",
      views: {
        'menuContent' :{
          templateUrl: "msg.html",
          controller: "RequestTopUpController"
        }
      }
    })
    .state('eventmenu.msg', {
      url: "/msg",
      views: {
        'menuContent' :{
          templateUrl: "msg.html",
          controller: "MessageController"
        	  
        }
      }
    })
    .state('eventmenu.sendlist', {
      url: "/sendlist",
      views: {	
        'menuContent' :{
          templateUrl: "sendlist.html"
        }
      }
    })
    .state('eventmenu.sendussd', {
      url: "/sendussd",
      views: {	
        'menuContent' :{
          templateUrl: "sendussd.html",
          controller: "SendUSSDController"
        }
      }
    })
    .state('eventmenu.sendsms', {
      url: "/sendsms",
      views: {	
        'menuContent' :{
          templateUrl: "sendsms.html",
          controller: "SendSMSController"
        }
      }
    })
    .state('eventmenu.help', {
      url: "/help",
      views: {
        'menuContent' :{
          templateUrl: "help/help.html"
        }
      }
    })
    .state('eventmenu.help_faq', {
      url: "/help/faq",
      views: {
        'menuContent' :{
          templateUrl: "help/faq.html"
        }
      }
    })
    .state('eventmenu.help_terms', {
      url: "/help/terms",
      views: {
        'menuContent' :{
          templateUrl: "help/terms.html"
        }
      }
    })
    .state('eventmenu.help_contact', {
      url: "/help/contact",
      views: {
        'menuContent' :{
          templateUrl: "help/contact.html",
          controller: "ContactController"
        }
      }
    })
    .state('eventmenu.help_feedback', {
      url: "/help/feedback",
      views: {
        'menuContent' :{
          templateUrl: "help/feedback.html",
          controller: "FeedbackController"
        }
      }
    })
    .state('eventmenu.help_invite', {
      url: "/help/invite",
      views: {
        'menuContent' :{
          templateUrl: "help/invite.html"
        }
      }
    })
                    
  $urlRouterProvider.otherwise("/event/home");
})
;


// ----- cordova & plugin

/*
function onLoad(){
	console.log("onLoad");
    document.addEventListener("deviceready", onDeviceReady, false);
}
function onDeviceReady(){
	console.log("onDeviceReady");
}    
*/


// test camera


var cvsDraw = function()
{
    try {
	var c = this.ctx;
	var w = this.width;
	var h = this.height;
	c.fillStyle="#ddd";

	c.fillRect(0,0,w,h);
	
	var t = w;
	
	if (this.img!=null)
	{
		var sx = 0;
		var sy = 0;
		var sw = this.img.width;
		var sh = this.img.height;
		
//		console.log("image: "+sw+"x"+sh);
		if (sh>sw) {
			sh = Math.round(t*sh/sw);
			sw = t;
			sy = Math.floor((t-sh)/2); 
		} else {
			sw = Math.round(t*sw/sh);
			sh = t;
			sx = Math.floor((t-sw)/2); 
		}
//		console.log(" >> "+sx+"x"+sy+" "+sw+"x"+sh);
		
		c.drawImage(this.img,sx,sy,sw,sh);
		
	}
	
	/*
	// zoom: (img,sx,sy,swidth,sheight,x,y,width,height)
	
	c.font="bold 30px sans-serif";
	c.shadowBlur=7;
	c.shadowColor="#000";
	c.fillStyle="#000";
	
	var t = "Hello World";
	var x = 20;
	var y = 40;

	c.fillStyle="#fb4";
	c.strokeStyle="#555";
	c.fillText(t,x,y);
	c.shadowBlur=0;
	c.lineWidth=0.5;
	c.strokeText(t,x,y);
	*/
	
	window.img_code = this.toDataURL("image/png");
	} catch (ex) { alert("draw err "+ex); }
	//.replace("image/png", "image/octet-stream");	
}

var canvasInit = function(id, w, h)
{
var c = document.getElementById(id);
if (c==null) return null;

c.s = c.style;
c.width=w;
c.height=h;

var ctx = c.getContext('2d');
c.ctx = ctx;

c.img = null;
c.draw = cvsDraw;

c.resize = function(w,h)
{
this.width=w;
this.height=h;
if (this.draw) this.draw();
}

return(c);
}

function getPic(src)
{
	/*
	cordova.exec(getPicSuccess, getPicFail, "CameraLauncher", "takePicture", [
      60,//this.mQuality
      0,//destType
      src,//srcType 0 1 ..
      200,//this.targetWidth
      200,//this.targetHeight
      0,//this.encodingType
      0,//this.mediaType
      false,//this.allowEdit
      true,//this.correctOrientation
      false//this.saveToPhotoAlbum
	]);
     */
    try{
    } catch(eee) {alert(eee); }
    var opts = { quality:60, destinationType: 0,
        targetWidth:200, targetHeight:200, sourceType: src,
        saveToPhotoAlbum: false};
    navigator.camera.getPicture(getPicSuccess,getPicFail,opts);
}

var _cvs;

function myPicInit(url) {
    var cvs = canvasInit("myCanvas",98,98);
    if (cvs) {
    	_cvs = cvs;
    	if (url) {
    		loadPic(url);
    	}
    }
}

function getPicSuccess(imageData) {
    //var image = document.getElementById('myImg');
    //image.src = "data:image/jpeg;base64," + imageData;

    var img = new Image();
    img.onload = function() {
    	_cvs.img = this;
    	_cvs.draw(); 
    	document.getElementById("div_ok").className="";
    	document.getElementById("div_select").className="gone";
    }
    img.src = "data:image/jpeg;base64," + imageData;
}

function loadPic(url) {
    var img = new Image();
    img.onload = function(){ _cvs.img = this; _cvs.draw(); }
    img.src = url;
}


function getPicFail(message) {
    console.log('takePicture failed: ' + message);
}


// -- alert();

function showAlert(msg, then) {
	var modal = document.getElementById('alert-modal');
	var modaltext = document.getElementById('alert-text');
	modaltext.innerHTML = msg.replace("&","&amp;").replace("<","&lt;").replace(">","&gt;");
	modal.then = then;
	modal.style.visibility = 'visible';
}

function hideAlert() {
	var modal = document.getElementById('alert-modal');
	modal.style.visibility = 'hidden';
	if (modal.then) modal.then();
}
